package Listes;

import java.util.*;

public class Liste{
    protected int type = 5;
    private LinkedList l = null;
    
    public int getType(){
        return type;
    }
    
    public LinkedList getList(){
        return l;
    }

 // Dfinitions par dfaut, la dfinition approprie sera dans la classe approprie.   
    public int valEntier(){
        System.out.println("Application de 'valEntier()'  un lment non entier");
        System.exit(1);
        return 0;
    }
    public double valDecimale(){
        System.out.println("Application de 'valDecimale()'  un lment non dcimal");
        System.exit(1);
        return 0;
    }
    public String valChaine(){
        System.out.println("Application de 'valChaine()'  un lment qui n'est pas une chaine");
        System.exit(1);
        return "";
    }
    
    public boolean valBool(){
        System.out.println("Application de 'valBool()'  un lment qui n'est pas un boolen");
        System.exit(1);
        return false;
    }
    
// Les prdicats
    public boolean entierP(){
        return type == 1;
    }
    
    public boolean nombreP(){
        return type <= 2;
    }
    
    public boolean decimalP(){
        return type == 2;
    }
    
    public boolean chaineP(){
        return type == 3;
    }
    
    public boolean booleenP(){
        return type == 4;
    }
    
    public boolean listeP(){
        return type == 5;
    }
// Le clonage d'une liste
    public Liste cloner(){
        Liste nl = new Liste();
        for(ListIterator i = l.listIterator(); i.hasNext();){
            nl.l.addLast( i.next());
        }
        return  nl;
    }
    
// Egalit

    public boolean equals(Object obj){
        // Ici aussi il faut accepter la slection par hritage
        if(! (obj instanceof Liste)){
            return false;
        }
        Liste elem = (Liste) obj;
        if (elem.type != 5){return false;}
        int k = l.size();
        int j = elem.getList().size();
        if (k != j) {return false;}
        for(int i = 0; i < k ; i++ ){
            if (!((Liste)l.get(i)).equals(elem.l.get(i))){
                return false;
            }
        }
        return true;
    }
  // Changer les noms ici pour eviter les confusions.
  // mais est-ce utile?
    public boolean equals(int i){
        if (type > 2){return false;}
        return equals(new Decimal(i));
    }
    
    public boolean equals(double i){
        if (type > 2){return false;}
        return equals(new Decimal(i));
    }
    
    public boolean equals(String ch){
        if (type != 3) {return false;}
        return equals(new Chaine(ch));
    }
    
    public boolean equals(boolean b){
        if (type != 4) {return false;}
        return equals(new Booleen(b));
    }
    
   // Constructeurs
    public Liste(){
        l = new LinkedList();
    }
    
    private Liste(LinkedList l1){
        l = new LinkedList();
        for(ListIterator i = l1.listIterator(); i.hasNext();){
            l.addLast(((Liste)i.next()).cloner());
        }
    }
    
    public Liste(int[] tab){
        l = new LinkedList();
        for(int i = 0; i < tab.length; i++){
            l.addLast(new Entier(tab[i]));
        }
    }
    
    public Liste(double[] tab){
        l = new LinkedList();
        for(int i = 0; i < tab.length; i++){
            l.addLast(new Decimal(tab[i]));
        }
    }
    
    public Liste(String[] tab){
        l = new LinkedList();
        for(int i = 0; i < tab.length; i++){
            l.addLast(new Chaine(tab[i]));
        }
    }
    
    public Liste(boolean[] tab){
        l = new LinkedList();
        for(int i = 0; i < tab.length; i++){
            l.addLast(new Booleen(tab[i]));
        }
    }
    
    /* Les fonctions d'ajout */
        // Au dbut
    public void fPut(int i){
        if (type != 5){return;}
        l.addFirst(new Entier(i));
    }
    
    public void fPut(double i){
        if (type != 5){return;}
        l.addFirst(new Decimal(i));
    }
    
    public void fPut(String ch){
        if (type != 5){return;}
        l.addFirst(new Chaine(ch));
    }
    
    public void fPut(boolean b){
        if (type != 5){return;}
        l.addFirst(new Booleen(b));
    }
    
    public void fPut(Liste L){
        if (type != 5){return;}
        l.addFirst(L.cloner());
    }
    
       // A la fin
    public void lPut(int i){
        if (type != 5){return;}
        l.addLast(new Entier(i));
    }
    
    public void lPut(double i){
        if (type != 5){return;}
        l.addLast(new Decimal(i));
    }
    
    public void lPut(String ch){
        if (type != 5){return;}
        l.addLast(new Chaine(ch));
    }
    
    public void lPut(boolean b){
        if (type != 5){return;}
        l.addLast(new Booleen(b));
    }
    
    public void lPut(Liste L){
        if (type != 5){return;}
        l.addLast(L.cloner());
    }
    
       // A un indice
    public void itemPut(int i, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemPut ne peut ajouter  l'indice " + index);
        }
        l.add(index, new Entier(i));
    }
    
    
    public void itemPut(double d, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemPut ne peut ajouter  l'indice " + index);
        }
        l.add(index, new Decimal(d));
    }
    
    
    public void itemPut(String ch, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemPut ne peut ajouter  l'indice " + index);
        }
        l.add(index, new Chaine(ch));
    }
    
    
    public void itemPut(boolean b, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemPut ne peut ajouter  l'indice " + index);
        }
        l.add(index, new Booleen(b));
    }
    
    
    public void itemPut(Liste L, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemPut ne peut ajouter  l'indice " + index);
        }
        l.add(index, L.cloner());
    }
    
    // Remplacement  un indice
    public void itemRemplace(int i, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemRemplace ne peut remplacer  l'indice " + index);
        }
        l.remove(index);
        l.add(index, new Entier(i));
    }
    
    
    public void itemRemplace(double d, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemRemplace ne peut remplacer  l'indice " + index);
        }
        l.remove(index);
        l.add(index, new Decimal(d));
    }
    
    
    public void itemRemplace(String ch, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemRemplace ne peut remplacer  l'indice " + index);
        }
        l.remove(index);
        l.add(index, new Chaine(ch));
    }
    
    
    public void itemRemplace(boolean b, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemRemplace ne peut remplacer  l'indice " + index);
        }
        l.remove(index);
        l.add(index, new Booleen(b));
    }
    
    
    public void itemRemplace(Liste L, int index) throws ListException{
        if (type != 5){return;}
        if (index<0 || index > l.size()){
            throw new ListException("itemPut ne peut ajouter  l'indice " + index);
        }
        l.remove(index);
        l.add(index, L.cloner());
    }
    
    /* Fonctions de lecture */
    
    public Liste first() throws ListException{
        if (type != 5){return null;}
        if (l.isEmpty()){
            throw new ListException("Tentative de lire le premier lment d'une liste vide!");
        }
        return (Liste) l.getFirst();
    }
    
    public Liste last() throws ListException{
        if (type != 5){return null;}
        if (l.isEmpty()){
            throw new ListException("Tentative de lire le dernier lment d'une liste vide!");
        }
        return (Liste) l.getLast();
    }
    
    public Liste item(int index) throws ListException{
        if (type != 5){return null;}
        if (index < 0 || index > l.size()){
            throw new ListException("Tentative de lire  un indice inexistant!");
        }
        return (Liste) l.get(index);
    }
    
    /* Fonctions de suppression */
    
    public Liste butFirst() throws ListException{
        if (type != 5){return null;}
        if (l.isEmpty()){
            throw new ListException("La liste n'a pas de premier lment, elle est vide!");
        }
        l.removeFirst();
        return this;
    }
    
    public Liste butLast() throws ListException{
        if (type != 5){return null;}
        if (l.isEmpty()){
            throw new ListException("La liste n'a pas de dernier lment, elle est vide!");
        }
        l.removeLast();
        return this;
    }
    
    public Liste butItem(int index) throws ListException{
        if (type != 5){return null;}
        if (index < 0 || index > l.size()){
            throw new ListException("Tentative de suppression  un indice inexistant!");
        }
        l.remove(index);
        return this;
    }
    
    /* Fonctions diverses */
    // le nombre d'lements
    public int count(){
        if (type != 5){
            return -1;
        }
        return l.size();
    }
    
    // ajouter la liste L  la fin de cette liste
    public void sentence(Liste L){
        if (type != 5 || L.getType() != 5){
            return;
        }
        l.addAll(L.l);
    }
    
    // prdicats
    public boolean emptyP(){
        return l.isEmpty();
    }
    
    public boolean memberP(Liste obj){
        int i = l.indexOf(obj);
        return (i != -1);
    }
    
    public boolean memberP(int i){
        return (memberP(new Entier(i)));
    }
    
    public boolean memberP(double d){
        return (memberP(new Decimal(d)));
    }
    
    public boolean memberP(String ch){
        return (memberP(new Chaine (ch)));
    }
    
    public boolean memberP(boolean b){
        return (memberP(new Booleen(b)));
    }
    
    public String toString(){
        String resultat = "[";
        for(ListIterator i = l.listIterator(); i.hasNext();){
            resultat += i.next().toString();
            if (i.hasNext()){
                resultat += ", ";
            }
        }
        return resultat + "]";
    }
    
    
}